5  REM * RF AND MICROWAVE II COMPUTER PROGRAM BY RONALD L. GEBHARDT JR. *
10  REM * THIS PROGRAM CALCULATES CONSTANT GAIN CIRCLES FOR THE
15  REM * NON-UNILATERAL CASE *
18  CLS
20  PRINT" This program calculates constant gain circles for the non-unilateral"
30  PRINT" case. You will be asked to enter in the S parameters of the device"
35  PRINT" you intend to use. Please do so in polar form. The program will then"
37  PRINT" ask you for the desired gain. Enter this value in dB. The program will"
40  PRINT" then return the location of the constant gain circles center and"
45  PRINT" its radius on the Smith Chart. "
50  PRINT:PRINT:PRINT:PRINT
51  PI=4*ATN(1):DG=180/PI
55  GOSUB 395
60  INPUT"ENTER IN THE DESIRED GAIN";YG
63  GOSUB 355
65  GOSUB 240
70  GOSUB 100
75  GOSUB 170
80  GOSUB 190
85  GOSUB 255
90  GOSUB 275
92  GOSUB 300
94  GOSUB 330
95  GOSUB 500
96  INPUT"WOULD YOU LIKE TO GO AGAIN? (Y OR N)";ANS$
97  IF ANS$<>"Y" THEN 99
98  GOTO 18
99  END
100  REM ******** CALCULATION OF DS **********
105  X = MS11*MS22
110  XA = AS11+AS22
115  Y=MS12*MS21
120  YA= AS12+AS21
121  XA=XA/DG
122  YA=YA/DG
125  XR = X*COS(XA)
130  XI = X*SIN(XA)
135  YR = Y*COS(YA)
140  YI = Y*SIN(YA)
145  XR=XR-YR
150  XI = XI-YI
155  DS=SQR(XR*XR+XI*XI)
160  DSA = DG*(ATN(XI/XR)-(SGN(XR)-1)*PI/2)
165  RETURN
170  REM ******* CALCULATION OF D2 *******
175  D2 = MS22*MS22-DS*DS
180  RETURN
190  REM ******* CALCULATION OF C2 *******
195  X = DS*MS11
200  XA = DSA-AS11
201  XA=XA*(PI/180)
205  XR = X*COS(XA)
210  XI=X*SIN(XA)
211  YA=AS22*(PI/180)
212  YR = MS22*COS(YA)
213  YI = MS22*SIN(YA)
215  X=YR-XR
220  XA=YI-XI
225  C2=SQR(X*X+XA*XA)
230  C2A = DG*(ATN(XA/X)-(SGN(X)-1)*PI/2)
235  RETURN
240  REM ***** CALCULATION OF G *****
245  G = GD/(MS21*MS21)
250  RETURN
255  REM **** CALCULATE DISTANCE FORM SMITH CHART CENTER ****
260  RO = (G*C2)/(1+D2*G)
265  RA = (-1)*C2A
266  IF RA>(-180) THEN 270
267  RA=RA+360
270  RETURN
275  REM **** CALCULATE STABILITY CONSTANT ******
280  K=(1+(DS*DS)-(MS11*MS11)-(MS22*MS22))
290  K=K/(2*MS21*MS12)
295  RETURN
300  REM ***** CALCULATE THE RADIUS OF THE CIRCLE *****
305  X= ABS(MS12*MS21)
310  Y=(2*K*X*G)-(X*X*G*G)
315  PO = SQR(1-Y)
320  PO = PO/(1+D2*G)
325  RETURN
330  REM ****** OUTPUT OF DATA ******
335  PRINT"THE DESIRED GAIN IS ";YG;" DB"
340  PRINT
345  PRINT" THE CENTER OF THE DESIRED GAIN CIRCLE IS LOCATED AT: ";RO;" ANGLE ";RA
346  PRINT"THE CIRCLE RADIUS IS:";PO
350  RETURN
355  REM ***** CONVERSION OF DB TO NON DB ******
360  GD = 10^(YG/10)
365  RETURN
395  REM ******* INPUT S-PARAMETERS *********
400  INPUT"ENTER THE MAGNITUDE OF S11";MS11
405  INPUT"ENTER THE ANGLE OF S11";AS11
410  INPUT"ENTER THE MAGNITUDE OF S12";MS12
415  INPUT"ENTER THE ANGLE OF S12";AS12
420  INPUT"ENTER THE MAGNITUDE OF S21";MS21
425  INPUT"ENTER THE ANGLE OF S21";AS21
430  INPUT"ENTER THE MAGNITUDE OF S22";MS22
435  INPUT"ENTER THE ANGLE OF S22";AS22
440  RETURN
500  REM ******* HARD COPY **************
505  INPUT"WOULD YOU LIKE A HARD COPY? (Y OR N)";ANS$
510  IF ANS$<>"Y" THEN 560
515  LPRINT,"S11 MAG. = ";MS11;" S11 ANGLE = ";AS11
520  LPRINT,"S12 MAG. = ";MS12;" S12 ANGLE = ";AS12
525  LPRINT,"S21 MAG. = ";MS21;" S21 ANGLE = ";AS21
530  LPRINT, "S22 MAG. = ";MS22;" S22 ANGLE = ";AS22
535  LPRINT:LPRINT:LPRINT
540  LPRINT"THE DESIRED GAIN IS ";YG;" DB"
545  LPRINT"THE CIRCLE CENTER IS LOCATED AT: ";RO;" ANGLE ";RA
550  LPRINT"THE CIRCLE RADIUS IS: ";PO
555  LPRINT:LPRINT:LPRINT
560  RETURN
